-module(action_bind).
%%-author('Maxim Sokhatsky').

-include_lib("nitro/include/nitro.hrl").
-include_lib("nitro/include/event.hrl").

-export([
  render_action/1
]).


render_action( #bind{postback = Code, target = {g, _} = Control, type = Type, source = Src} ) ->
  %% rebind same control to same handler on same target
  G = wf_event:target(Control),
  V = nitro:to_binary(Src),
  E = nitro:to_binary(Type),
  ["{ if('", V, "' in ", G, "){",
        G, ".removeEventListener('", E, "',", V, ");"
        "delete ", G, "[", V, "]};",
      V, "={handleEvent:(event) => { if(event.type === '", E, "'){", nitro:to_binary(Code), "}}};",
      G, ".addEventListener('", E, "',", V, ");",
      G, ".", V, "=", V, ";}"];

render_action( #bind{postback = Code, target = Control, type = Type} ) ->
  ["{var x=", wf_event:target(Control), ";"
      "x && x.addEventListener('", nitro:to_binary(Type), "',"
        "function(event){", nitro:to_binary(Code), "});}" ].

