-module(action_jq).
%%-author('Rusty Klophaus').
%%-author('Andrey Martemyanov').

-include_lib("nitro/include/nitro.hrl").

-export([
  render_action/1
]).


render_action( #jq{property = undefined, target = T, method = Methods, args = Args0, format = F} ) ->
  Args = case F of
    "'~s'" -> [ nitro:render(Args0) ];
    _ -> Args0
  end,
  Format = fun(A) when erlang:is_tuple(A) orelse erlang:is_integer(A) ->
                     nitro:render(A);
              (A) -> nitro:to_list(A)
  end,
  RenderedArgs = string:join([ Format(A) || A <- Args], ","),
  {Op, Op2} = case T of
    {qa, _} -> {".map(i=>i.", ");"};
    {_, {qa, _}, _} -> {".map(i=>i.", ");"};
    _ -> {".", ";"}
  end,
  [ [ wf_event:target(T), Op, nitro:to_binary(M), "(", nitro:f(F, [RenderedArgs]), ")", Op2 ] || M <- Methods];

render_action( #jq{target = T, method = undefined, property = P, right = R, args = simple}) -> [ nitro:to_binary(T), ".", nitro:to_binary(P), "='", nitro:render(R), "';" ];
render_action( #jq{target = T, method = undefined, property = P, right = undefined} )       -> [ wf_event:target(T), ".", nitro:to_binary(P), ";" ];
render_action( #jq{target = T, method = undefined, property = P, right = #jq{} = R})        -> [ wf_event:target(T), ".", nitro:to_binary(P), "=", nitro:render(R), ";" ];
render_action( #jq{target = T, method = undefined, property = P, right = R})                -> [ wf_event:target(T), ".", nitro:to_binary(P), "='", nitro:render(R), "';" ].

