-module(element_date).
%%-author('Vladimir Galunshchikov').

-include_lib("nitro/include/nitro.hrl").
-include_lib("nitro/include/event.hrl").

-export([
  render_element/1
]).


render_element(Record) when Record#date.show_if == false -> [<<>>];

render_element(Record) ->
  Id = case Record#date.postback of
    [] -> Record#date.id;
    Postback ->
      ID0 = case Record#date.id of
        [] -> nitro:temp_id();
        I -> I
      end,
      nitro:wire( #event{type = click, postback = Postback, target = ID0,
                         source = Record#date.source,
                         delegate = Record#date.delegate} ),
      ID0
  end,
  List = [
    %% global
    {<<"accesskey">>, Record#date.accesskey},
    {<<"class">>, Record#date.class},
    {<<"contenteditable">>,
       case Record#date.contenteditable of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"contextmenu">>, Record#date.contextmenu},
    {<<"dir">>,
       case Record#date.dir of
         ltr -> "ltr";
         rtl -> "rtl";
         auto -> "auto";
         _ -> []
       end},
    
    {<<"draggable">>,
       case Record#date.draggable of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"dropzone">>, Record#date.dropzone},
    {<<"hidden">>,
       case Record#date.hidden of
         true -> "hidden";
         _ -> []
       end},
    
    {<<"id">>, Id},
    {<<"lang">>, Record#date.lang},
    {<<"spellcheck">>,
       case Record#date.spellcheck of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"style">>, Record#date.style},
    {<<"tabindex">>, Record#date.tabindex},
    {<<"title">>, Record#date.title},
    {<<"translate">>,
       case Record#date.contenteditable of
         true -> "yes";
         false -> "no";
         _ -> []
       end},
    
    %% spec
    {<<"autocomplete">>,
       case Record#date.autocomplete of
         true -> "on";
         false -> "off";
         _ -> []
       end},
    
    {<<"autofocus">>,
       case Record#date.autofocus of
         true -> "autofocus";
         _ -> []
       end},
    
    {<<"disabled">>,
       case Record#date.disabled of
         true -> "disabled";
         _ -> []
       end},
    
    {<<"form">>, Record#date.form},
    {<<"list">>, Record#date.list},
    {<<"max">>, Record#date.max},
    {<<"min">>, Record#date.min},
    {<<"name">>, Record#date.name},
    {<<"readonly">>,
       case Record#date.readonly of
         true -> "readonly";
         _ -> []
       end},
    
    {<<"required">>,
       case Record#date.required of
         true -> "required";
         _ -> []
       end},
    
    {<<"step">>, Record#date.step},
    {<<"type">>, <<"date">>},
    {<<"value">>, Record#date.value} | Record#date.data_fields
  ],
  
  wf_tags:emit_tag(<<"input">>, nitro:render(Record#date.body), List).

